import unittest
import statements as s


class SimpleTest(unittest.TestCase):

    # Test function AND
    def test1FunctionAND(self):
        self.assertTrue(s.AND(True,False) == False)

    def test2FunctionAND(self):
        self.assertTrue(s.AND(True,True) == True)

    def test3FunctionAND(self):
        self.assertTrue(s.AND(False,True) == False)

    def test4FunctionAND(self):
        self.assertTrue(s.AND(False,False) == False)

    # Test function OR
    def test1FunctionOR(self):
        self.assertTrue(s.OR(True, False) == True)

    def test2FunctionOR(self):
        self.assertTrue(s.OR(True, True) == True)

    def test3FunctionOR(self):
        self.assertTrue(s.OR(False, True) == True)

    def test4FunctionOR(self):
        self.assertTrue(s.OR(False, False) == False)

    # Test function NEGATION
    def test1FunctionNEGATION(self):
        self.assertTrue(s.NEGATION(True) == False)

    def test2FunctionNEGATION(self):
        self.assertTrue(s.NEGATION(False) == True)

    #Test function NAND
    def test1FunctionNAND(self):
        self.assertTrue(s.NAND(True, False) == True)

    def test2FunctionNAND(self):
        self.assertTrue(s.NAND(True, True) == False)

    def test3FunctionNAND(self):
        self.assertTrue(s.NAND(False, True) == True)

    def test4FunctionNAND(self):
        self.assertTrue(s.NAND(False, False) == True)


    #Test function NOR
    def test1FunctionNOR(self):
        self.assertTrue(s.NOR(True, False) == False)

    def test2FunctionNOR(self):
        self.assertTrue(s.NOR(True, True) == False)

    def test3FunctionNOR(self):
        self.assertTrue(s.NOR(False, True) == False)

    def test4FunctionNOR(self):
        self.assertTrue(s.NOR(False, False) == True)


    #Test function XOR
    def test1FunctionXOR(self):
        self.assertTrue(s.XOR(True, False) == True)

    def test2FunctionXOR(self):
        self.assertTrue(s.XOR(True, True) == False)

    def test3FunctionXOR(self):
        self.assertTrue(s.XOR(False, True) == True)

    def test4FunctionXOR(self):
        self.assertTrue(s.XOR(False, False) == False)

    # Test complication problems
    def test1ComplicatedProblem(self):

        step1 = s.AND(False, False)
        step2 = s.OR(step1, False)

        self.assertTrue(step2 == False)

    def test2ComplicatedProblem(self):
        step1 = s.AND(True, False)
        step2 = s.OR(step1, True)

        self.assertTrue(step2 == True)

    def test3ComplicatedProblem(self):
        step1 = s.AND(True, True)
        step2 = s.OR(step1, False)

        self.assertTrue(step2 == True)

    def test4ComplicatedProblem(self):
        step1 = s.AND(True, False)
        step2 = s.OR(step1, False)

        self.assertTrue(step2 == False)

    def test5ComplicatedProblem(self):

        step1 = s.AND(False, False)
        step2 = s.OR(step1, True)
        self.assertTrue(step2 == True)

    def test6ComplicatedProblem(self):

        step1 = s.NAND(True, False)
        step2 = s.XOR(step1, True)
        step3 = s.NOR(s.NEGATION(step2),step1)
        step4 = s.OR(step3, False)
        step5 = s.XOR(step4,step3)
        self.assertTrue(step5 == False)


if __name__ == '__main__':
    unittest.main()
